#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"

int log2fer(int a) {
    int b=1;
    int c=0;
    while (b<a) {c++; b*=2;}
    return c;
}

int hat2(int a) {
    int b=1;
    int i;
    for (i=0; i<a; i++)
	b*=2;
    return b;
}

int main(){
    int N = 2;				// lassitas "merteke"
    int meddig, tasknum, kinek;
    int reszeredmeny=0;
    int i=0;
    int j=0;
    int eredmeny=0;
    int en=0;
    int log=0;
    int mytid = pvm_mytid();

    pvm_recv(pvm_parent(),2);
    pvm_upkint(&meddig,1,1);
    pvm_upkint(&tasknum,1,1);

    int tids[tasknum+1];
    pvm_recv(pvm_parent(),0);
    pvm_upkint(tids,tasknum+1,1);		

    while ( (en<tasknum) && (tids[en]!=mytid) )
	en++;
        
    log=log2fer(en);

    for (i=0; i<=log; i++) {
	if (i==0 && en<tasknum) {				// 1. sorbol kuldes szomszednak
	    eredmeny=en;
            pvm_initsend(PvmDataDefault);
    	    pvm_pkint(&eredmeny, 1, 1);
	    pvm_send(tids[en+1],1);
	}
	else {
	    pvm_recv(tids[en-hat2(i-1)], 1);			// fogadok reszeredemenyt
	    pvm_upkint(&reszeredmeny, 1, 1);
	    eredmeny += reszeredmeny;
	    if (i!=log && i>0 && en+hat2(i)<=tasknum) {		// koztes pontokbol kuldes
	        pvm_initsend(PvmDataDefault);
		pvm_pkint(&eredmeny, 1, 1);
		pvm_send(tids[en+hat2(i)],1);
	    }
	}
    
    }

    kinek = en;
    j=0;
    kinek += hat2(log+j);
    while (en<tasknum && kinek<tasknum) {			// vegso pontokbol kuldes
        j++;
        pvm_initsend(PvmDataDefault);
	pvm_pkint(&eredmeny, 1, 1);
        pvm_send(tids[kinek],1);
	kinek += hat2(log-1+j);
    }

    for (j=0; j<N*1000000; j++) {				// lassitas
	kinek=kinek*2;
	kinek=kinek/2;
    }

    printf("A(z) %d reszfa reszeredmenye: %d\n", en, eredmeny);
    if (en==tasknum-1) {
    	pvm_initsend(PvmDataDefault);
    	pvm_pkint(&eredmeny,1,1);
	pvm_send(tids[0], 1);
    }
    pvm_exit();
    return 1;
}
