#include <stdio.h>
#include <stdlib.h>
#include <sys/timeb.h>
#include "pvm3.h"

int main(int argc, char* argv[] ){
    if (argc!=2) {
	fprintf(stderr,"Meg kell adni parameterkent, hogy meddig adjak ossze!\n");
        pvm_exit();
    }
    else {
	int eredmeny;
        int meddig = atoi(argv[1])+1;
        int tasknum = meddig;
        int tids[tasknum+1];
	struct timeb kezdes;
	struct timeb vegzes;	
	long eltelt;
	short milisec;

        tids[0] = pvm_mytid();
        pvm_spawn("plusz",(char **)NULL,0,"",tasknum,tids+1);

	ftime(&kezdes);

        pvm_initsend(PvmDataDefault);
        pvm_pkint(&meddig,1,1);
        pvm_pkint(&tasknum,1,1);
        pvm_mcast(tids+1,tasknum,2);

        pvm_initsend(PvmDataDefault);
        pvm_pkint(tids,tasknum+1,1);
        pvm_mcast(tids+1,tasknum,0);

        pvm_recv(tids[tasknum-1],1);
        pvm_upkint(&eredmeny,1,1);

	ftime(&vegzes);

        printf("Az eredmeny: %d\n", eredmeny);
	
        eltelt=vegzes.time-kezdes.time;
	if (vegzes.millitm<kezdes.millitm)     {
	    eltelt--;
	    milisec=kezdes.millitm-vegzes.millitm;
	} 
	else {
	    milisec=vegzes.millitm-kezdes.millitm;
	}
	printf("Futasi ido: %ld.%03u\n",eltelt,milisec);

	
        pvm_exit();
    }
    return 1;
}
